<?php

/**
 * @copyright (C) 2008 by Slashes & Dots Sdn Bhd - All rights reserved!
 * @license http://www.azrul.com Copyrighted Commercial Software
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once( JPATH_BASE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');

class plgCommunityEventlist extends CApplications
{

	var $name 		= "Eventlist Application";
	var $_name		= 'eventlist';
	var $_path		= '';
	var $_user		= '';
	var $_my		= '';

    function plgCommunityEventlist(& $subject, $config)
    {
    	$this->_path	= JPATH_BASE . DS . 'administrator' . DS . 'components' . DS . 'com_eventlist';
		$this->_user	= CFactory::getActiveProfile();
		$this->_my		= CFactory::getUser();
			
		parent::__construct($subject, $config);
    }

	/**
	 * Return itemid for Eventlist
	 */	 	
	function getItemid()
	{
		$db =& JFactory::getDBO();
		$Itemid = 0;

    	if ($Itemid < 1)
		{
        	$db->setQuery("SELECT id FROM #__menu WHERE link LIKE '%index.php?option=com_eventlist%' AND published = 1");
        	$Itemid = $db->loadResult();

        	if ($Itemid < 1)
			{
         	   $Itemid = 0;
        	}
    	}
	    
	    return $Itemid;
	}
	
	function onProfileDisplay()
	{
		// Load language
		JPlugin::loadLanguage( 'plg_eventlist', JPATH_ADMINISTRATOR );
				
		// Attach CSS
		$document	=& JFactory::getDocument();
		$css		= JURI::base() . 'plugins/community/eventlist/style.css';
		$document->addStyleSheet($css);
		
		$html  		 = "\n".'<!--[if lte IE 6]>'."\n";
		$html 		.= '<link rel="stylesheet" type="text/css" href="'. JURI::base() . 'plugins/community/eventlist/styleIE6.css" type="text/css" />'."\n";
		$html 		.= '<![endif]-->'."\n";
		$document->addCustomTag( $html );
		
		if( !file_exists( $this->_path . DS . 'admin.eventlist.php' ) ){
			$el_exist = 0;
			$content = "<div class=\"icon-nopost\"><img src='".JURI::base()."components/com_community/assets/error.gif' alt=\"\" /></div>";	
			$content .= "<div class=\"content-nopost\">".JText::_('PLG_EVENTLIST EVENTLIST NOT INSTALLED')."</div>";
		}else{
			$user		= CFactory::getActiveProfile();
			$userName = $user->getDisplayName();
			$userId = $user->id;
			$events	= $this->_getEvents();
			$itemId = $this->getItemid();
			$el_exist = 1;
			
			$cache =& JFactory::getCache('plgCommunityEventlist');
			$cache->setCaching($this->params->get('cache', 1));
			$callback = array('plgCommunityEventlist', '_getEventListHTML');
			
			$content = $cache->call($callback, $userName, $userId, $el_exist, $events, $itemId);
		}	
		return $content;
	}
	
	function _getEventListHTML($userName, $userId, $el_exist, $events, $itemId){
		ob_start();
		// Test if seyret really exists on this environment.
		if($el_exist)
		{			
			if( !$events )
			{
				?>
				<div class="icon-nopost">
		            <img src="<?php echo JURI::base(); ?>plugins/community/eventlist/favicon.png" alt="" />
		        </div>
		        <div class="content-nopost">
		            <?php echo $userName; ?> <?php echo JText::_('PLG_EVENTLIST NO EVENT JOINED'); ?>
		        </div>
				<?php
			}
			else
			{
			?>
				<div id="community-eventlist-wrap">
				    <table cellpadding="2" cellspacing="0" border="0" width="100%">
					
					<?php foreach( $events as $event ): ?>
					    <tr>
					        <td width="15">
					            <img src="<?php echo JURI::base(); ?>plugins/community/eventlist/favicon.png" alt="" />
					        </td>
					        <td valign="top">
					            <a href="<?php echo JRoute::_('index.php?option=com_eventlist&view=details&id=' . $event->slug . '&Itemid=' . $itemId);?>">
									<?php echo $event->title; ?>
								</a>
								<?php if( !empty( $event->venue ) ): ?>
									<?php echo JText::_('PLG_EVENTLIST AT'); ?>
									<a href="<?php echo JRoute::_( 'index.php?option=com_eventlist&view=venueevents&id=' . $event->venueslug . '&Itemid=' . $itemId);?>"><?php echo $event->venue;?></a>
								<?php endif; ?>
							</td valign="top">
					        
					        <td width="150" align="right">
							<?php
								$start		= new JDate($event->dates);
								echo $start->toFormat( '%d/%m/%Y' );
								echo ' - ';
								$end		= new JDate($event->enddates);
								echo $end->toFormat( '%d/%m/%Y' );
							?>
					        </td>
						</tr>
					<?php endforeach; ?>
					</table>
				</div>
			<?php
			}
		}
		
		$content	= ob_get_contents();
		ob_end_clean();
		return $content;
	}
	
	/**
	 * Returns the list of videos and its properties for the specific browsed user
	 * 
	 * @access private
	 * 
	 * returns	Array	An array of object list
	 **/	 	
	function _getEvents()
	{
		$db		=& JFactory::getDBO();
		$limit	= '10';
		
		$query	= 'SELECT *, '
				. 'CASE WHEN CHAR_LENGTH( b.alias ) THEN CONCAT_WS(\':\',b.id,b.alias) ELSE b.id END AS slug '
				. 'FROM ' . $db->nameQuote( '#__eventlist_register' ) . ' AS a '
				. 'INNER JOIN ' . $db->nameQuote( '#__eventlist_events' ) . ' AS b ON a.event=b.id '
				. 'AND a.uid=' . $db->Quote( $this->_user->id ) . ' '
				. 'AND b.published=' . $db->Quote( '1' ) . ' '
				. 'LIMIT 0,' . $limit;
		$db->setQuery( $query );

		$result = $db->loadObjectList();

		// Attach the venues if there are any
		foreach( $result as $row )
		{
			$query	= 'SELECT ' . $db->nameQuote('id') . ',' . $db->nameQuote('venue') . ','
					. 'CASE WHEN CHAR_LENGTH( alias ) THEN CONCAT_WS(\':\',id,alias) ELSE id END AS slug '
					. 'FROM ' . $db->nameQuote( '#__eventlist_venues') . ' '
					. 'WHERE ' . $db->nameQuote( 'id' ) . '=' . $db->Quote( $row->locid );

			$db->setQuery( $query );

			$venue			= $db->loadObject();
 			$row->venue		= $venue->venue;
 			$row->venueslug	= $venue->slug;
		}		
		return $result; 
	}
}
